diff --git a/Documentation/howto/dpdk.rst b/Documentation/howto/dpdk.rst
index 6397d25f16ad..766a7950ce9b 100644
--- a/Documentation/howto/dpdk.rst
+++ b/Documentation/howto/dpdk.rst
@@ -25,14 +25,15 @@
 Using Open vSwitch with DPDK
 ============================
 
-This document describes how to use Open vSwitch with DPDK datapath.
+This document describes how to use Open vSwitch with DPDK.
 
 .. important::
 
-   Using the DPDK datapath requires building OVS with DPDK support. The
-   mapping of OVS version to DPDK can vary between releases. For version
-   mapping information refer to :doc:`releases FAQ </faq/releases>`. For
-   build instructions refer to :doc:`/intro/install/dpdk`.
+   Using DPDK with OVS requires configuring OVS at build time to use
+   the DPDK library.  The version of DPDK that OVS supports varies
+   from one OVS release to another, as described in the :doc:`releases
+   FAQ </faq/releases>`. For build instructions refer to
+   :doc:`/intro/install/dpdk`.
 
 Ports and Bridges
 -----------------
diff --git a/Documentation/howto/userspace-tunneling.rst b/Documentation/howto/userspace-tunneling.rst
index 1b9d8b9eb469..0122ce76e9b7 100644
--- a/Documentation/howto/userspace-tunneling.rst
+++ b/Documentation/howto/userspace-tunneling.rst
@@ -74,8 +74,8 @@ Two Physical Hosts
 The environment assumes the use of two hosts, named `host1` and `host2`. We
 only detail the configuration of `host1` but a similar configuration can be
 used for `host2`. Both hosts should be configured with Open vSwitch (with or
-without the DPDK datapath), QEMU/KVM and suitable VM images. Open vSwitch
-should be running before proceeding.
+without DPDK), QEMU/KVM and suitable VM images. Open vSwitch should be running
+before proceeding.
 
 Configuration Steps
 -------------------
diff --git a/Documentation/intro/install/distributions.rst b/Documentation/intro/install/distributions.rst
index 5987178eaafc..54362c0a495e 100644
--- a/Documentation/intro/install/distributions.rst
+++ b/Documentation/intro/install/distributions.rst
@@ -46,8 +46,8 @@ that includes the core userspace components of the switch.
 automatically build and install Open vSwitch kernel module for your running
 kernel.
 
-3. For DPDK datapath, Open vSwitch with DPDK support is bundled in the package
-``openvswitch-switch-dpdk``.
+3. For fast userspace switching, Open vSwitch with DPDK support is
+bundled in the package ``openvswitch-switch-dpdk``.
 
 Fedora
 ------
diff --git a/Documentation/intro/install/dpdk.rst b/Documentation/intro/install/dpdk.rst
index 6e5f1ea60af2..50de7fbac7bf 100644
--- a/Documentation/intro/install/dpdk.rst
+++ b/Documentation/intro/install/dpdk.rst
@@ -107,8 +107,8 @@ Install DPDK
 Install OVS
 ~~~~~~~~~~~
 
-OVS can be installed using different methods. For OVS to use DPDK datapath, it
-has to be configured with DPDK support (``--with-dpdk``).
+OVS can be installed using different methods.  For OVS to use DPDK, it
+has to be configured to build against the DPDK library (``--with-dpdk``).
 
 .. note::
   This section focuses on generic recipe that suits most cases. For
@@ -288,7 +288,7 @@ with either the ovs-vswitchd logs, or by running either of the commands::
   "DPDK 17.11.0"
 
 At this point you can use ovs-vsctl to set up bridges and other Open vSwitch
-features. Seeing as we've configured the DPDK datapath, we will use DPDK-type
+features. Seeing as we've configured DPDK support, we will use DPDK-type
 ports. For example, to create a userspace bridge named ``br0`` and add two
 ``dpdk`` ports to it, run::
 
diff --git a/Documentation/topics/dpdk/bridge.rst b/Documentation/topics/dpdk/bridge.rst
index 4ca79a4abd58..d9bc7eba4230 100644
--- a/Documentation/topics/dpdk/bridge.rst
+++ b/Documentation/topics/dpdk/bridge.rst
@@ -25,13 +25,14 @@
 DPDK Bridges
 ============
 
-The DPDK datapath requires specially configured bridge(s) in order to utilize
-DPDK-backed :doc:`physical <phy>` and :doc:`virtual <vhost-user>` ports.
+Bridge must be specially configured to utilize DPDK-backed
+:doc:`physical <phy>` and :doc:`virtual <vhost-user>` ports.
 
 Quick Example
 -------------
 
-This example demonstrates how to add a bridge using the DPDK datapath::
+This example demonstrates how to add a bridge that will take advantage
+of DPDK::
 
     $ ovs-vsctl add-br br0 -- set bridge br0 datapath_type=netdev
 
diff --git a/Documentation/topics/dpdk/index.rst b/Documentation/topics/dpdk/index.rst
index cf24a7b6d47d..f2862ea7019a 100644
--- a/Documentation/topics/dpdk/index.rst
+++ b/Documentation/topics/dpdk/index.rst
@@ -21,9 +21,9 @@
 
       Avoid deeper levels because they do not render well.
 
-=================
-The DPDK Datapath
-=================
+============
+DPDK Support
+============
 
 .. NOTE(stephenfin): Part of this doc is included in 'howto/dpdk'. Update that
 .. if you modify this document
diff --git a/Documentation/topics/dpdk/phy.rst b/Documentation/topics/dpdk/phy.rst
index 93d74df45286..9f36e8dfc12c 100644
--- a/Documentation/topics/dpdk/phy.rst
+++ b/Documentation/topics/dpdk/phy.rst
@@ -125,11 +125,11 @@ Multiqueue
 ----------
 
 Poll Mode Driver (PMD) threads are the threads that do the heavy lifting for
-the DPDK datapath. Correct configuration of PMD threads and the Rx queues they
-utilize is a requirement in order to deliver the high-performance possible with
-DPDK acceleration. It is possible to configure multiple Rx queues for ``dpdk``
-ports, thus ensuring this is not a bottleneck for performance. For information
-on configuring PMD threads, refer to :doc:`pmd`.
+DPDK userspace switching. Correct configuration of PMD threads and the Rx
+queues they utilize is a requirement in order to deliver the high-performance
+possible with DPDK acceleration. It is possible to configure multiple Rx queues
+for ``dpdk`` ports, thus ensuring this is not a bottleneck for performance. For
+information on configuring PMD threads, refer to :doc:`pmd`.
 
 .. _dpdk-phy-flow-control:
 
diff --git a/Documentation/topics/dpdk/pmd.rst b/Documentation/topics/dpdk/pmd.rst
index b0e19d794b7c..ffa74f0c0043 100644
--- a/Documentation/topics/dpdk/pmd.rst
+++ b/Documentation/topics/dpdk/pmd.rst
@@ -26,9 +26,9 @@ PMD Threads
 ===========
 
 Poll Mode Driver (PMD) threads are the threads that do the heavy lifting for
-the DPDK datapath and perform tasks such as continuous polling of input ports
-for packets, classifying packets once received, and executing actions on the
-packets once they are classified.
+DPDK userspace switching.  They perform tasks such as continuous polling of
+input ports for packets, classifying packets once received, and executing
+actions on the packets once they are classified.
 
 PMD threads utilize Receive (Rx) and Transmit (Tx) queues, commonly known as
 *rxq*\s and *txq*\s. While Tx queue configuration happens automatically, Rx
diff --git a/Documentation/topics/dpdk/ring.rst b/Documentation/topics/dpdk/ring.rst
index e48b44ce8038..af0531178ab7 100644
--- a/Documentation/topics/dpdk/ring.rst
+++ b/Documentation/topics/dpdk/ring.rst
@@ -32,7 +32,7 @@ DPDK Ring Ports
    :doc:`vhost-user ports <vhost-user>` are a better choice and should be used
    instead.
 
-The DPDK datapath provides DPDK-backed ring ports that are implemented using
+OVS DPDK support provides DPDK-backed ring ports that are implemented using
 DPDK's ``librte_ring`` library. For more information on this library, refer to
 the `DPDK documentation`_.
 
diff --git a/Documentation/topics/dpdk/vhost-user.rst b/Documentation/topics/dpdk/vhost-user.rst
index fab87bd3dbe7..73647dcda257 100644
--- a/Documentation/topics/dpdk/vhost-user.rst
+++ b/Documentation/topics/dpdk/vhost-user.rst
@@ -25,7 +25,7 @@
 DPDK vHost User Ports
 =====================
 
-The DPDK datapath provides DPDK-backed vHost user ports as a primary way to
+OVS support for DPDK provides DPDK-backed vHost user ports as a primary way to
 interact with guests. For more information on vHost User, refer to the `QEMU
 documentation`_ on same.
 
diff --git a/Documentation/topics/testing.rst b/Documentation/topics/testing.rst
index 31433c591744..8b5d268e02df 100644
--- a/Documentation/topics/testing.rst
+++ b/Documentation/topics/testing.rst
@@ -324,8 +324,8 @@ The results of the testsuite are in ``tests/system-userspace-testsuite.dir``.
 All the features documented under `Unit Tests`_ are available for the userspace
 datapath testsuite.
 
-DPDK datapath
-'''''''''''''
+Userspace datapath with DPDK
+''''''''''''''''''''''''''''
 
 To test :doc:`/intro/install/dpdk` (i.e., the build was configured with
 ``--with-dpdk``, the DPDK is installed), run the testsuite and generate
diff --git a/acinclude.m4 b/acinclude.m4
index 07c83b15bcbc..2eb8892fbfc8 100644
--- a/acinclude.m4
+++ b/acinclude.m4
@@ -289,7 +289,7 @@ AC_DEFUN([OVS_CHECK_DPDK], [
                               [Specify the DPDK build directory])],
               [have_dpdk=true])
 
-  AC_MSG_CHECKING([whether dpdk datapath is enabled])
+  AC_MSG_CHECKING([whether dpdk is enabled])
   if test "$have_dpdk" != true || test "$with_dpdk" = no; then
     AC_MSG_RESULT([no])
     DPDKLIB_FOUND=false
diff --git a/tests/system-dpdk.at b/tests/system-dpdk.at
index 1da020aba0c7..a015d52f7935 100644
--- a/tests/system-dpdk.at
+++ b/tests/system-dpdk.at
@@ -5,7 +5,7 @@ AT_BANNER([OVS-DPDK unit tests])
 
 dnl --------------------------------------------------------------------------
 dnl Check if EAL init is successful
-AT_SETUP([OVS-DPDK datapath - EAL init])
+AT_SETUP([OVS-DPDK - EAL init])
 AT_KEYWORDS([dpdk])
 OVS_DPDK_PRE_CHECK()
 OVS_DPDK_START()
@@ -23,7 +23,7 @@ dnl --------------------------------------------------------------------------
 
 dnl --------------------------------------------------------------------------
 dnl Add standard DPDK PHY port
-AT_SETUP([OVS-DPDK datapath - add standard DPDK port])
+AT_SETUP([OVS-DPDK - add standard DPDK port])
 AT_KEYWORDS([dpdk])
 
 OVS_DPDK_PRE_PHY_SKIP()
@@ -50,7 +50,7 @@ dnl --------------------------------------------------------------------------
 
 dnl --------------------------------------------------------------------------
 dnl Add vhost-user-client port
-AT_SETUP([OVS-DPDK datapath - add vhost-user-client port])
+AT_SETUP([OVS-DPDK - add vhost-user-client port])
 AT_KEYWORDS([dpdk])
 OVS_DPDK_PRE_CHECK()
 OVS_DPDK_START()
@@ -82,7 +82,7 @@ dnl --------------------------------------------------------------------------
 
 dnl --------------------------------------------------------------------------
 dnl Ping vhost-user port
-AT_SETUP([OVS-DPDK datapath - ping vhost-user ports])
+AT_SETUP([OVS-DPDK - ping vhost-user ports])
 AT_KEYWORDS([dpdk])
 OVS_DPDK_PRE_CHECK()
 AT_SKIP_IF([! which testpmd >/dev/null 2>/dev/null])
@@ -159,7 +159,7 @@ dnl --------------------------------------------------------------------------
 
 dnl --------------------------------------------------------------------------
 dnl Ping vhost-user-client port
-AT_SETUP([OVS-DPDK datapath - ping vhost-user-client ports])
+AT_SETUP([OVS-DPDK - ping vhost-user-client ports])
 AT_KEYWORDS([dpdk])
 OVS_DPDK_PRE_CHECK()
 AT_SKIP_IF([! which testpmd >/dev/null 2>/dev/null])
diff --git a/vswitchd/ovs-vswitchd.8.in b/vswitchd/ovs-vswitchd.8.in
index a5cdc3aa4991..63df1541c848 100644
--- a/vswitchd/ovs-vswitchd.8.in
+++ b/vswitchd/ovs-vswitchd.8.in
@@ -79,9 +79,8 @@ only allow privileged users, such as the superuser, to use it.
 unavailable or unsuccessful.
 .
 .SS "DPDK Options"
-For details on initializing the \fBovs\-vswitchd\fR DPDK datapath,
-refer to the documentation or \fBovs\-vswitchd.conf.db\fR(5) for
-details.
+For details on initializing \fBovs\-vswitchd\fR to use DPDK ports,
+refer to the documentation or \fBovs\-vswitchd.conf.db\fR(5).
 .SS "Daemon Options"
 .ds DD \
 \fBovs\-vswitchd\fR detaches only after it has connected to the \